﻿#region Copyright
/* Copyright 2009-2010 Oliver Sturm <oliver@sturmnet.org> All rights reserved. */
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ShowFilteredListParallel {
  public partial class Form1 : Form {
    public Form1( ) {
      InitializeComponent( );

      InitData(new List<Person>{
        new Person { Name = "Anna" },
        new Person { Name = "Chris" },
        new Person { Name = "Willy" },
        new Person { Name = "Hugh" },
        new Person { Name = "Steve" },
        new Person { Name = "Betty" },
        new Person { Name = "Carla" },
        new Person { Name = "John" },
        new Person { Name = "Pete" },
        new Person { Name = "Susan" }
      });
    }

    private void InitData(List<Person> data) {
      Action updateUI = delegate {
        DisplayListBox.DataSource =
          GetFilteredList(data, GetFilterString( ));
      };
      FilterButton.Click += delegate { updateUI( ); };
      updateUI( );
    }

    string GetFilterString( ) {
      return String.IsNullOrEmpty(FilterTextBox.Text) ?
        null : FilterTextBox.Text;
    }

    private static List<Person> GetFilteredList(List<Person> source, string filter) {
      return filter == null ? source : 
        (from p in source.AsParallel()
         where p.Name.Contains(filter)
         select p).ToList( );
    }
  }
}